"""
DO NOT EDIT THIS FILE!!
This file is automatically generated by the process_schemas.py program
in the scripts directory. It is not intended to be edited directly. If
you need to update the GEL protocol classes, please run the script
on the appropriate schema version.
"""
from protocols.protocol import (
    ProtocolElement,
    avro_parse,
    load_schema,
)


class Phenotypes(ProtocolElement):
    """
    Oontology term based on the OBO format (see an example here
    http://snapshot.geneontology.org/ontology/go-basic.obo)
    """

    # load schema from file
    _schemaSource = load_schema(__file__)
    # parse into avro classes
    schema = avro_parse(_schemaSource)

    requiredFields = {}

    @classmethod
    def getEmbeddedTypes(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_8_4 import reports as reports_6_8_0

        return {
            "standardPhenotypes": reports_6_8_0.StandardPhenotype,
        }

    @classmethod
    def getEmbeddedEnums(cls):
        return {}

    @classmethod
    def getEmbeddedByNamespace(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_8_4 import reports as reports_6_8_0

        return {
            "org.gel.models.report.avro.StandardPhenotype": reports_6_8_0.StandardPhenotype,
            "org.gel.models.report.avro.Phenotypes": reports_6_8_0.Phenotypes,
        }

    __slots__ = [
        "nonStandardPhenotype",
        "standardPhenotypes",
    ]

    def __init__(
        self,
        nonStandardPhenotype=None,
        standardPhenotypes=None,
        validate=None,
        **kwargs
    ):
        """Initialise the reports_6_8_0.Phenotypes model.

        :param nonStandardPhenotype:
            The non standardised phenotypes (i.e.: may be free text)
        :type nonStandardPhenotype: None | list[str]
        :param standardPhenotypes:
            The standardised phenotypes (i.e.: controlled terminology)
        :type standardPhenotypes: None | list[StandardPhenotype]
        """

        attributes = {k: v for k, v in locals().items() if k not in ["self", "unknown"]}
        ProtocolElement.__init__(self, **attributes)

    @classmethod
    def _namespace_version(cls):
        return "6.8.0"
